// Generated by CoffeeScript 1.6.3
var applyConfig, browserify, chokidar, configs, crypto, depsBundle, depsCache, framework, fs, hash, os, path, preprocessor, through, tmp, watch, watcher, writeDeps,
  __indexOf = [].indexOf || function(item) { for (var i = 0, l = this.length; i < l; i++) { if (i in this && this[i] === item) return i; } return -1; };

crypto = require('crypto');

path = require('path');

os = require('os');

fs = require('fs');

browserify = require('browserify');

through = require('through');

chokidar = require('chokidar');

depsCache = [];

depsBundle = null;

tmp = null;

configs = ['extension', 'transform', 'ignore'];

hash = function(what) {
  return crypto.createHash('md5').update(what).digest('base64').slice(0, 6);
};

applyConfig = function(b, cfg) {
  var c, v, _i, _len, _results;
  _results = [];
  for (_i = 0, _len = configs.length; _i < _len; _i++) {
    c = configs[_i];
    _results.push((function() {
      var _j, _len1, _ref, _results1;
      if ((cfg[c] != null) && (b[c] != null)) {
        _ref = [].concat(cfg[c]);
        _results1 = [];
        for (_j = 0, _len1 = _ref.length; _j < _len1; _j++) {
          v = _ref[_j];
          _results1.push(b[c](v));
        }
        return _results1;
      }
    })());
  }
  return _results;
};

writeDeps = function(callback) {
  return depsBundle.bundle(function(err, depsContent) {
    if (err) {
      return err;
    }
    return fs.writeFile(tmp, depsContent, function(err) {
      if (err) {
        return err;
      }
      if (callback != null) {
        return callback();
      }
    });
  });
};

watcher = null;

watch = function(file) {
  if (watcher != null) {
    return watcher.add(file);
  }
  watcher = chokidar.watch(file);
  return watcher.on('change', function() {
    return writeDeps();
  });
};

framework = function(files, config) {
  tmp = path.join(os.tmpdir(), 'karma-browerify.js');
  fs.writeFileSync(tmp, '');
  files.unshift({
    pattern: tmp,
    included: true,
    served: true,
    watched: true
  });
  depsBundle = browserify();
  return applyConfig(depsBundle, config);
};

preprocessor = function(logger, config) {
  var log;
  log = logger.create('preprocessor.browserify');
  return function(content, file, done) {
    var deps, fileBundle;
    log.debug('Processing "%s".', file.originalPath);
    fileBundle = browserify(file.originalPath);
    applyConfig(fileBundle, config);
    deps = function(opts) {
      return fileBundle.deps(opts).pipe(through(function(row) {
        var _ref;
        if (row.id !== file.originalPath) {
          if (_ref = row.id, __indexOf.call(depsCache, _ref) < 0) {
            depsCache.push(row.id);
          }
          row.source = "module.exports=require('" + (hash(row.id)) + "');";
        }
        return this.queue(row);
      }));
    };
    return fileBundle.bundle({
      deps: deps
    }, function(err, fileContent) {
      var d, _i, _len;
      for (_i = 0, _len = depsCache.length; _i < _len; _i++) {
        d = depsCache[_i];
        if (!(__indexOf.call(depsBundle.files, d) < 0)) {
          continue;
        }
        depsBundle.require(d, {
          expose: d
        });
        if (config.watch) {
          watch(d);
        }
      }
      return writeDeps(function() {
        return done(fileContent);
      });
    });
  };
};

framework.$inject = ['config.files', 'config.browserify'];

preprocessor.$inject = ['logger', 'config.browserify'];

module.exports = {
  'preprocessor:browserify': ['factory', preprocessor],
  'framework:browserify': ['factory', framework]
};
